diff -ruN vdr-1.7.7/CONTRIBUTORS vdr-1.7.8/CONTRIBUTORS
--- vdr-1.7.7/CONTRIBUTORS	2009-05-03 16:45:53.000000000 +0200
+++ vdr-1.7.8/CONTRIBUTORS	2009-06-13 15:35:49.000000000 +0200
@@ -672,6 +672,8 @@
  VPID is 0
  for reporting chirping sound disturbences at editing points in TS recordings
  for reporting broken index generation in TS recordings after a buffer overflow
+ for fixing the way the OSD size is determined on full featured DVB cards
+ for his input on calculating the Aspect factor in GetOsdSize()
 
 Reinhard Walter Buchner <rw.buchner@freenet.de>
  for adding some satellites to 'sources.conf'
@@ -918,6 +920,8 @@
  for a hint on using _nl_msg_cat_cntr
  for adding some missing 'const' keywords
  for pointing out that "%016llX" should be used instead of "%016LX"
+ for adding some missing 'const' keywords to avoid compilation errors with gcc 4.4
+ for reporting that cSVDRP::CmdGRAB() writes into const data
 
 Thomas Koch <tom@harhar.net>
  for his support in keeping the Premiere World channels up to date in 'channels.conf'
@@ -1073,6 +1077,8 @@
  for replacing the Finnish language code "smi" with "suo"
  for adding cap_sys_nice to the capabilities that are not dropped
  for adding cThread::SetIOPriority() and using it in cRemoveDeletedRecordingsThread
+ for suggesting to introduce cDevice::GetOsdSize()
+ for adding a note about the meaning of PERCENTAGEDELTA in cRingBuffer::UpdatePercentage()
 
 Ralf Klueber <ralf.klueber@vodafone.com>
  for reporting a bug in cutting a recording if there is only a single editing mark
@@ -1212,6 +1218,17 @@
  for making sure vdr-xine no longer needs cDvbPlayer::Action() to call DeviceFlush()
  for fixing the 'VideoOnly' condition in the PlayPes() and PlayTs() calls in
  cDvbPlayer::Action()
+ for reporting a problem in case the PIDs change during recording
+ for reporting a memory leak when reaching the end of a recording during replay
+ for reporting a call to close(-1) in cUnbufferedFile::Close()
+ for reporting a possible problem in handling the length of DiSEqC command sequences
+ for fixing cOsdMenu::Display() in case the menu size has changed
+ for suggesting to change the type of the Aspect parameter of GetVideoSize()
+ to 'double'
+ for suggesting to use different names for the Aspect parameter in GetVideoSize()
+ and GetOsdSize()
+ for reporting a problem with calculating menu colum widths in case the font has a
+ size other than the default size
 
 Richard Robson <richard_robson@beeb.net>
  for reporting freezing replay if a timer starts while in Transfer Mode from the
@@ -1623,6 +1640,7 @@
  for reporting a problem with handling the maximum video file size
  for suggesting to add a note to the INSTALL file about using subdirectories to
  split a large disk into separate areas for VDR's video data and other stuff
+ for reporting wrong variable types in cIndexFile
 
 Sven Kreiensen <svenk@kammer.uni-hannover.de>
  for his help in keeping 'channels.conf.terr' up to date
@@ -1814,6 +1832,7 @@
  menu
  for adding missing #include <limits.h> to epg.c and menuitems.h
  for fixing various spelling errors and improving PLUGINS.html
+ for adding some missing 'const' keywords to avoid compilation errors with gcc 4.4
 
 Steffen Beyer <cpunk@reactor.de>
  for fixing setting the colored button help after deleting a recording in case the next
@@ -1953,6 +1972,7 @@
 
 Nicolas Huillard <nhuillard@e-dition.fr>
  for translating OSD texts to the French language
+ for suggesting to increase MAXOSDHEIGHT to 1200
 
 Patrick Fischer <patrick_fischer@gmx.de>
  for reporting an error in the cFilter example in PLUGINS.html
@@ -2126,6 +2146,9 @@
  check to it
  for changing cBitmap::DrawText() to always draw the background unless ColorBg
  is clrTransparent
+ for reporting unused 'synced' member in cTsToPes
+ for suggesting to add a note to cTsToPes about all TS packets having to belong to
+ the same PID
 
 Pekka Mauno <pekka.mauno@iki.fi>
  for fixing cSchedule::GetFollowingEvent() in case there is currently no present
@@ -2164,6 +2187,7 @@
  for fixing a signed character used as index in cBase64Encoder::NextLine()
  for fixing formatting the name section in the VDR man pages
  for reporting unneeded include files <linux/dvb/dmx.h> und <time.h> in remux.h
+ for a patch that added a workaround for the broken linux-dvb driver header files
 
 Helge Lenz <h.lenz@gmx.de>
  for reporting a bug in setting the 'Delta' parameter when calling the shutdown
@@ -2310,6 +2334,8 @@
  for optimizing cNitFilter::Process()
  for reducing the number of time(NULL) calls in vdr.c's main loop to a single call
  for improving efficiency of cEIT::cEIT()
+ for fixing the use of time_t in cEIT::cEIT()
+ for making EIT events be processed only if a plausible system time is available
 
 Bruno Roussel <bruno.roussel@free.fr>
  for translating OSD texts to the French language
@@ -2331,6 +2357,7 @@
 Timo Eskola <timo@tolleri.net>
  for implementing sending all frames to devices that can handle them in fast forward
  trick speeds
+ for implementing the setup option "Recording/Pause key handling"
 
 Elias Luttinen <el@iki.fi>
  for improving the description of where logging goes in the INSTALL file
@@ -2394,6 +2421,7 @@
 Ales Jurik <ajurik@quick.cz>
  for reporting broken SI data on Czech/Slovak channels after changing the default
  character set to ISO-8859-9
+ for adding MPEG 1 handling to remux.c
 
 Magnus Andersson <svankan@bahnhof.se>
  for translating OSD texts to the Swedish language
@@ -2446,3 +2474,7 @@
 
 Günter Niedermeier <linuxtv@ncs-online.de>
  for reporting a problem with file I/O overhead during recording in TS format
+
+Martin Neuditschko <yosuke.tomoe@gmx.net>
+ for reporting a problem with error messages from cDvbDevice::GetVideoSize()
+ on systems with no real primary replay device
diff -ruN vdr-1.7.7/HISTORY vdr-1.7.8/HISTORY
--- vdr-1.7.7/HISTORY	2009-05-03 16:45:17.000000000 +0200
+++ vdr-1.7.8/HISTORY	2009-06-13 15:35:31.000000000 +0200
@@ -6074,3 +6074,64 @@
   (provided the output device implements the GetVideoSize() function).
 - cFrameDetector::Analyze() now syncs on the TS packet sync bytes (thanks to
   Oliver Endriss for reporting broken index generation after a buffer overflow).
+
+2009-06-13: Version 1.7.8
+
+- The name of the function cDevice::GetVideoSize() wasn't very well chosen
+  for its purpose of defining the optimum size of the OSD for the current
+  output device. Therefore a new function named cDevice::GetOsdSize() has
+  been introduced (suggested by Rolf Ahrenberg). Plugin authors should
+  implement this function in classes derived from cDevice, if they are able
+  to replay video. cDevice::GetVideoSize() still exists and should return the
+  actual size of the video material that is currently replayed. Note that
+  because of the many possible aspect ratios for video material, the type
+  of the Aspect parameter of GetVideoSize() has been changed to 'double',
+  and the Aspect parameter in both functions is named differently, because
+  it returns different values (suggested by Reinhard Nissl).
+  Thanks to Oliver Endriss for his input on calculating the Aspect factor in
+  GetOsdSize().
+- Fixed the way the OSD size is determined on full featured DVB cards (thanks
+  to Oliver Endriss).
+- Increased MAXOSDHEIGHT to 1200 (suggested by Nicolas Huillard).
+- Removed limitation to PAL resolution from SPU handling.
+- Checking fd_video in cDvbDevice::GetVideoSize() to avoid error messages on
+  systems with no real primary replay device (reported by Martin Neuditschko).
+- Added a note to cTsToPes::GetPes() about having to call it repeatedly, once
+  it has returned a non-NULL value.
+- Added MPEG 1 handling to remux.c (thanks to Ales Jurik).
+- Fixed use of time_t in cEIT::cEIT() (thanks to Tobias Bratfisch).
+- Added missing update of lastOsdSizeUpdate.
+- EIT events are now only processed if a plausible system time is available, to
+  avoid wrong handling of PDC descriptors (thanks to Tobias Bratfisch).
+- Removed unused 'synced' member from cTsToPes (reported by Christoph Haubrich).
+- Added a note to cTsToPes about all TS packets having to belong to the same PID,
+  and that for video data GetPes() may only be called if the next TS packet that
+  will be given to PutTs() has the "payload start" flag set (suggested by Christoph
+  Haubrich).
+- Added a note about the meaning of PERCENTAGEDELTA in cRingBuffer::UpdatePercentage()
+  (thanks to Rolf Ahrenberg).
+- The new setup option "Recording/Pause key handling" can be used to define
+  what happens if the Pause key on the remote control is pressed during
+  live tv (thanks to Timo Eskola).
+- Added a note about cFont::GetFont() not being thread-safe.
+- Fixed generating PAT/PMT version numbers in case the PIDs change during
+  recording (reported by Reinhard Nissl).
+- Updated the Ukrainian OSD texts (thanks to Yarema Aka Knedlyk).
+- Fixed a memory leak when reaching the end of a recording during replay (reported
+  by Reinhard Nissl).
+- Fixed calling close(-1) in cUnbufferedFile::Close() (reported by Reinhard Nissl).
+- Added a workaround for the broken linux-dvb driver header files (based on a patch
+  from Tobias Grimm).
+- Fixed handling the length of DiSEqC command sequences (reported by Reinhard Nissl).
+- Fixed cOsdMenu::Display() in case the menu size has changed (thanks to
+  Reinhard Nissl).
+- Added some missing 'const' keywords to avoid compilation errors with gcc 4.4
+  (thanks to Ville Skyttä and Ludwig Nussel).
+- Modified cSVDRP::CmdGRAB() to avoid writing into const data (reported by
+  Ludwig Nussel).
+- Fixed calculating menu colum widths in case the font has a size other than the
+  default size (reported by Reinhard Nissl).
+- Added a plausibility check for the OSD percentage parameters
+  to avoid problems in case the values are stored in the setup.conf
+  file in a  wrong way.
+- Fixed variable types in cIndexFile (reported by Udo Richter).
diff -ruN vdr-1.7.7/MANUAL vdr-1.7.8/MANUAL
--- vdr-1.7.7/MANUAL	2009-05-03 16:04:22.000000000 +0200
+++ vdr-1.7.8/MANUAL	2009-05-21 13:28:41.000000000 +0200
@@ -748,6 +748,13 @@
   Pause priority = 10    The Priority and Lifetime values used when pausing live
   Pause lifetime = 1     video.
 
+  Pause key handling = 3 Defines what happens if the Pause key on the remote control
+                         is pressed during live tv.
+                         0 = do not pause live video
+                         1 = confirm pause live video
+                         2 = pause live video
+                         The default is 2.
+
   Use episode name = yes Repeating timers use the EPG's 'Episode name' information
                          to create recording file names in a hierarchical structure
                          (for instance to gather all episodes of a series in a
diff -ruN vdr-1.7.7/config.c vdr-1.7.8/config.c
--- vdr-1.7.7/config.c	2009-05-03 15:58:08.000000000 +0200
+++ vdr-1.7.8/config.c	2009-06-13 12:25:05.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: config.c 2.2 2009/05/03 13:58:08 kls Exp $
+ * $Id: config.c 2.5 2009/06/13 10:25:05 kls Exp $
  */
 
 #include "config.h"
@@ -20,6 +20,8 @@
 // format characters in order to allow any number of blanks after a numeric
 // value!
 
+#define ChkDoublePlausibility(Variable, Default) { if (Variable < 0.00001) Variable = Default; }
+
 // --- cCommand --------------------------------------------------------------
 
 char *cCommand::result = NULL;
@@ -250,6 +252,7 @@
   PrimaryLimit = 0;
   DefaultPriority = 50;
   DefaultLifetime = 99;
+  PauseKeyHandling = 2;
   PausePriority = 10;
   PauseLifetime = 1;
   UseSubtitle = 1;
@@ -270,6 +273,7 @@
   OSDTop = 45;
   OSDWidth = 624;
   OSDHeight = 486;
+  OSDAspect = 1.0;
   OSDMessageTime = 1;
   UseSmallFont = 1;
   AntiAlias = 1;
@@ -435,6 +439,7 @@
   else if (!strcasecmp(Name, "PrimaryLimit"))        PrimaryLimit       = atoi(Value);
   else if (!strcasecmp(Name, "DefaultPriority"))     DefaultPriority    = atoi(Value);
   else if (!strcasecmp(Name, "DefaultLifetime"))     DefaultLifetime    = atoi(Value);
+  else if (!strcasecmp(Name, "PauseKeyHandling"))    PauseKeyHandling   = atoi(Value);
   else if (!strcasecmp(Name, "PausePriority"))       PausePriority      = atoi(Value);
   else if (!strcasecmp(Name, "PauseLifetime"))       PauseLifetime      = atoi(Value);
   else if (!strcasecmp(Name, "UseSubtitle"))         UseSubtitle        = atoi(Value);
@@ -449,21 +454,22 @@
   else if (!strcasecmp(Name, "ChannelInfoTime"))     ChannelInfoTime    = atoi(Value);
   else if (!strcasecmp(Name, "OSDLeftP"))            OSDLeftP           = atof(Value);
   else if (!strcasecmp(Name, "OSDTopP"))             OSDTopP            = atof(Value);
-  else if (!strcasecmp(Name, "OSDWidthP"))           OSDWidthP          = atof(Value);
-  else if (!strcasecmp(Name, "OSDHeightP"))          OSDHeightP         = atof(Value);
+  else if (!strcasecmp(Name, "OSDWidthP"))         { OSDWidthP          = atof(Value); ChkDoublePlausibility(OSDWidthP, 0.87); }
+  else if (!strcasecmp(Name, "OSDHeightP"))        { OSDHeightP         = atof(Value); ChkDoublePlausibility(OSDHeightP, 0.84); }
   else if (!strcasecmp(Name, "OSDLeft"))             OSDLeft            = atoi(Value);
   else if (!strcasecmp(Name, "OSDTop"))              OSDTop             = atoi(Value);
   else if (!strcasecmp(Name, "OSDWidth"))          { OSDWidth           = atoi(Value); OSDWidth &= ~0x07; } // OSD width must be a multiple of 8
   else if (!strcasecmp(Name, "OSDHeight"))           OSDHeight          = atoi(Value);
+  else if (!strcasecmp(Name, "OSDAspect"))           OSDAspect          = atof(Value);
   else if (!strcasecmp(Name, "OSDMessageTime"))      OSDMessageTime     = atoi(Value);
   else if (!strcasecmp(Name, "UseSmallFont"))        UseSmallFont       = atoi(Value);
   else if (!strcasecmp(Name, "AntiAlias"))           AntiAlias          = atoi(Value);
   else if (!strcasecmp(Name, "FontOsd"))             Utf8Strn0Cpy(FontOsd, Value, MAXFONTNAME);
   else if (!strcasecmp(Name, "FontSml"))             Utf8Strn0Cpy(FontSml, Value, MAXFONTNAME);
   else if (!strcasecmp(Name, "FontFix"))             Utf8Strn0Cpy(FontFix, Value, MAXFONTNAME);
-  else if (!strcasecmp(Name, "FontOsdSizeP"))        FontOsdSizeP       = atof(Value);
-  else if (!strcasecmp(Name, "FontSmlSizeP"))        FontSmlSizeP       = atof(Value);
-  else if (!strcasecmp(Name, "FontFixSizeP"))        FontFixSizeP       = atof(Value);
+  else if (!strcasecmp(Name, "FontOsdSizeP"))      { FontOsdSizeP       = atof(Value); ChkDoublePlausibility(FontOsdSizeP, 0.038); }
+  else if (!strcasecmp(Name, "FontSmlSizeP"))      { FontSmlSizeP       = atof(Value); ChkDoublePlausibility(FontSmlSizeP, 0.035); }
+  else if (!strcasecmp(Name, "FontFixSizeP"))      { FontFixSizeP       = atof(Value); ChkDoublePlausibility(FontFixSizeP, 0.031); }
   else if (!strcasecmp(Name, "FontOsdSize"))         FontOsdSize        = atoi(Value);
   else if (!strcasecmp(Name, "FontSmlSize"))         FontSmlSize        = atoi(Value);
   else if (!strcasecmp(Name, "FontFixSize"))         FontFixSize        = atoi(Value);
@@ -525,6 +531,7 @@
   Store("PrimaryLimit",       PrimaryLimit);
   Store("DefaultPriority",    DefaultPriority);
   Store("DefaultLifetime",    DefaultLifetime);
+  Store("PauseKeyHandling",   PauseKeyHandling);
   Store("PausePriority",      PausePriority);
   Store("PauseLifetime",      PauseLifetime);
   Store("UseSubtitle",        UseSubtitle);
@@ -545,6 +552,7 @@
   Store("OSDTop",             OSDTop);
   Store("OSDWidth",           OSDWidth);
   Store("OSDHeight",          OSDHeight);
+  Store("OSDAspect",          OSDAspect);
   Store("OSDMessageTime",     OSDMessageTime);
   Store("UseSmallFont",       UseSmallFont);
   Store("AntiAlias",          AntiAlias);
diff -ruN vdr-1.7.7/config.h vdr-1.7.8/config.h
--- vdr-1.7.7/config.h	2009-05-03 15:15:35.000000000 +0200
+++ vdr-1.7.8/config.h	2009-05-21 13:11:32.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: config.h 2.9 2009/05/03 13:15:35 kls Exp $
+ * $Id: config.h 2.13 2009/05/21 11:11:32 kls Exp $
  */
 
 #ifndef __CONFIG_H
@@ -22,13 +22,13 @@
 
 // VDR's own version number:
 
-#define VDRVERSION  "1.7.7"
-#define VDRVERSNUM   10707  // Version * 10000 + Major * 100 + Minor
+#define VDRVERSION  "1.7.8"
+#define VDRVERSNUM   10708  // Version * 10000 + Major * 100 + Minor
 
 // The plugin API's version number:
 
-#define APIVERSION  "1.7.7"
-#define APIVERSNUM   10707  // Version * 10000 + Major * 100 + Minor
+#define APIVERSION  "1.7.8"
+#define APIVERSNUM   10708  // Version * 10000 + Major * 100 + Minor
 
 // When loading plugins, VDR searches them by their APIVERSION, which
 // may be smaller than VDRVERSION in case there have been no changes to
@@ -42,7 +42,7 @@
 #define MINOSDWIDTH   480
 #define MAXOSDWIDTH  1920
 #define MINOSDHEIGHT  324
-#define MAXOSDHEIGHT 1080
+#define MAXOSDHEIGHT 1200
 
 #define MaxFileName 256
 #define MaxSkinName 16
@@ -234,6 +234,7 @@
   int PrimaryLimit;
   int DefaultPriority, DefaultLifetime;
   int PausePriority, PauseLifetime;
+  int PauseKeyHandling;
   int UseSubtitle;
   int UseVps;
   int VpsMargin;
@@ -246,6 +247,7 @@
   int ChannelInfoTime;
   double OSDLeftP, OSDTopP, OSDWidthP, OSDHeightP;
   int OSDLeft, OSDTop, OSDWidth, OSDHeight;
+  double OSDAspect;
   int OSDMessageTime;
   int UseSmallFont;
   int AntiAlias;
diff -ruN vdr-1.7.7/device.c vdr-1.7.8/device.c
--- vdr-1.7.7/device.c	2009-05-02 14:17:39.000000000 +0200
+++ vdr-1.7.8/device.c	2009-06-06 15:25:58.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: device.c 2.17 2009/05/02 12:17:39 kls Exp $
+ * $Id: device.c 2.23 2009/06/06 13:25:58 kls Exp $
  */
 
 #include "device.h"
@@ -19,11 +19,6 @@
 #include "status.h"
 #include "transfer.h"
 
-const char *VideoAspectString[] = { "4:3",
-                                    "16:9",
-                                    "2.21:9"
-                                  };
-
 // --- cLiveSubtitle ---------------------------------------------------------
 
 class cLiveSubtitle : public cReceiver {
@@ -66,6 +61,7 @@
 cDevice *cDevice::avoidDevice = NULL;
 
 cDevice::cDevice(void)
+:patPmtParser(true)
 {
   cardIndex = nextCardIndex++;
 
@@ -389,11 +385,18 @@
   return vsPAL;
 }
 
-void cDevice::GetVideoSize(int &Width, int &Height, eVideoAspect &Aspect)
+void cDevice::GetVideoSize(int &Width, int &Height, double &VideoAspect)
+{
+  Width = 0;
+  Height = 0;
+  VideoAspect = 1.0;
+}
+
+void cDevice::GetOsdSize(int &Width, int &Height, double &PixelAspect)
 {
-  Width = MINOSDWIDTH;
-  Height = MINOSDHEIGHT;
-  Aspect = va4_3;
+  Width = 720;
+  Height = 480;
+  PixelAspect = 1.0;
 }
 
 //#define PRINTPIDS(s) { char b[500]; char *q = b; q += sprintf(q, "%d %s ", CardIndex(), s); for (int i = 0; i < MAXPIDHANDLES; i++) q += sprintf(q, " %s%4d %d", i == ptOther ? "* " : "", pidHandles[i].pid, pidHandles[i].used); dsyslog(b); }
diff -ruN vdr-1.7.7/device.h vdr-1.7.8/device.h
--- vdr-1.7.7/device.h	2009-05-02 14:16:20.000000000 +0200
+++ vdr-1.7.8/device.h	2009-06-06 13:15:49.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: device.h 2.10 2009/05/02 12:16:20 kls Exp $
+ * $Id: device.h 2.15 2009/06/06 11:15:49 kls Exp $
  */
 
 #ifndef __DEVICE_H
@@ -56,13 +56,6 @@
                     vsNTSC
                   };
 
-enum eVideoAspect { va4_3,
-                    va16_9,
-                    va221_9
-                  };
-
-extern const char *VideoAspectString[];
-
 enum eVideoDisplayFormat { vdfPanAndScan,
                            vdfLetterBox,
                            vdfCenterCutOut
@@ -384,9 +377,25 @@
   virtual eVideoSystem GetVideoSystem(void);
          ///< Returns the video system of the currently displayed material
          ///< (default is PAL).
-  virtual void GetVideoSize(int &Width, int &Height, eVideoAspect &Aspect);
-         ///< Returns the With, Height and Aspect ratio of the currently
-         ///< displayed material.
+  virtual void GetVideoSize(int &Width, int &Height, double &VideoAspect);
+         ///< Returns the With, Height and VideoAspect ratio of the currently
+         ///< displayed video material. The data returned by this function is
+         ///< only used for informational purposes (if any). Width and
+         ///< Height are given in pixel (e.g. 720x576) and VideoAspect is
+         ///< e.g. 1.33333 for a 4:3 broadcast, or 1.77778 for 16:9.
+         ///< The default implementation returns 0 for Width and Height
+         ///< and 1.0 for VideoAspect.
+  virtual void GetOsdSize(int &Width, int &Height, double &PixelAspect);
+         ///< Returns the With, Height and PixelAspect ratio the OSD should use
+         ///< to best fit the resolution of the output device. If PixelAspect
+         ///< is not 1.0, the OSD may take this as a hint to scale its
+         ///< graphics in a way that, e.g., a circle will actually
+         ///< show up as a circle on the screen, and not as an ellipse.
+         ///< Values greater than 1.0 mean to stretch the graphics in the
+         ///< vertical direction (or shrink it in the horizontal direction,
+         ///< depending on which dimension shall be fixed). Values less than
+         ///< 1.0 work the other way round. Note that the OSD is not guaranteed
+         ///< to actually use this hint.
 
 // Track facilities
 
diff -ruN vdr-1.7.7/dvbdevice.c vdr-1.7.8/dvbdevice.c
--- vdr-1.7.7/dvbdevice.c	2009-05-03 15:49:41.000000000 +0200
+++ vdr-1.7.8/dvbdevice.c	2009-06-06 13:17:20.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: dvbdevice.c 2.15 2009/05/03 13:49:41 kls Exp $
+ * $Id: dvbdevice.c 2.21 2009/06/06 11:17:20 kls Exp $
  */
 
 #include "dvbdevice.h"
@@ -232,8 +232,8 @@
                          uchar *codes = diseqc->Codes(n);
                          if (codes) {
                             struct dvb_diseqc_master_cmd cmd;
-                            memcpy(cmd.msg, codes, min(n, int(sizeof(cmd.msg))));
-                            cmd.msg_len = n;
+                            cmd.msg_len = min(n, int(sizeof(cmd.msg)));
+                            memcpy(cmd.msg, codes, cmd.msg_len);
                             CHECK(ioctl(fd_frontend, FE_DISEQC_SEND_MASTER_CMD, &cmd));
                             }
                          }
@@ -736,31 +736,62 @@
 eVideoSystem cDvbDevice::GetVideoSystem(void)
 {
   eVideoSystem VideoSystem = vsPAL;
-  video_size_t vs;
-  if (ioctl(fd_video, VIDEO_GET_SIZE, &vs) == 0) {
-     if (vs.h == 480 || vs.h == 240)
-        VideoSystem = vsNTSC;
+  if (fd_video >= 0) {
+     video_size_t vs;
+     if (ioctl(fd_video, VIDEO_GET_SIZE, &vs) == 0) {
+        if (vs.h == 480 || vs.h == 240)
+           VideoSystem = vsNTSC;
+        }
+     else
+        LOG_ERROR;
      }
-  else
-     LOG_ERROR;
   return VideoSystem;
 }
 
-void cDvbDevice::GetVideoSize(int &Width, int &Height, eVideoAspect &Aspect)
+void cDvbDevice::GetVideoSize(int &Width, int &Height, double &VideoAspect)
 {
-  video_size_t vs;
-  if (ioctl(fd_video, VIDEO_GET_SIZE, &vs) == 0) {
-     Width = vs.w;
-     if (Width < 720) // FIXME: some channels result in a With of, e.g. 544, but the final video *is* 720 wide
+  if (fd_video >= 0) {
+     video_size_t vs;
+     if (ioctl(fd_video, VIDEO_GET_SIZE, &vs) == 0) {
+        Width = vs.w;
+        Height = vs.h;
+        switch (vs.aspect_ratio) {
+          default:
+          case VIDEO_FORMAT_4_3:   VideoAspect =  4.0 / 3.0; break;
+          case VIDEO_FORMAT_16_9:  VideoAspect = 16.0 / 9.0; break;
+          case VIDEO_FORMAT_221_1: VideoAspect =       2.21; break;
+          }
+        return;
+        }
+     else
+        LOG_ERROR;
+     }
+  cDevice::GetVideoSize(Width, Height, VideoAspect);
+}
+
+void cDvbDevice::GetOsdSize(int &Width, int &Height, double &PixelAspect)
+{
+  if (fd_video >= 0) {
+     video_size_t vs;
+     if (ioctl(fd_video, VIDEO_GET_SIZE, &vs) == 0) {
         Width = 720;
-     Height = vs.h;
-     Aspect = eVideoAspect(vs.aspect_ratio);
-     if (Width >= MINOSDWIDTH && Width <= MAXOSDWIDTH && Height >= MINOSDHEIGHT && Height <= MAXOSDHEIGHT)
+        if (vs.h != 480 && vs.h != 240)
+           Height = 576; // PAL
+        else
+           Height = 480; // NTSC
+        switch (Setup.VideoFormat ? vs.aspect_ratio : VIDEO_FORMAT_4_3) {
+          default:
+          case VIDEO_FORMAT_4_3:   PixelAspect =  4.0 / 3.0; break;
+          case VIDEO_FORMAT_221_1: // FF DVB cards only distinguish between 4:3 and 16:9
+          case VIDEO_FORMAT_16_9:  PixelAspect = 16.0 / 9.0; break;
+          }
+        PixelAspect /= double(Width) / Height;
         return;
+        }
+     else
+        LOG_ERROR;
      }
-  else
-     LOG_ERROR;
-  cDevice::GetVideoSize(Width, Height, Aspect);
+  cDevice::GetOsdSize(Width, Height, PixelAspect);
 }
 
 bool cDvbDevice::SetAudioBypass(bool On)
diff -ruN vdr-1.7.7/dvbdevice.h vdr-1.7.8/dvbdevice.h
--- vdr-1.7.7/dvbdevice.h	2009-05-02 12:44:40.000000000 +0200
+++ vdr-1.7.8/dvbdevice.h	2009-06-06 13:16:47.000000000 +0200
@@ -4,12 +4,13 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: dvbdevice.h 2.4 2009/05/02 10:44:40 kls Exp $
+ * $Id: dvbdevice.h 2.8 2009/06/06 11:16:47 kls Exp $
  */
 
 #ifndef __DVBDEVICE_H
 #define __DVBDEVICE_H
 
+#include <sys/mman.h> // FIXME: workaround for broken linux-dvb header files
 #include <linux/dvb/frontend.h>
 #include <linux/dvb/version.h>
 #include "device.h"
@@ -107,7 +108,8 @@
   virtual void SetVideoDisplayFormat(eVideoDisplayFormat VideoDisplayFormat);
   virtual void SetVideoFormat(bool VideoFormat16_9);
   virtual eVideoSystem GetVideoSystem(void);
-  virtual void GetVideoSize(int &Width, int &Height, eVideoAspect &Aspect);
+  virtual void GetVideoSize(int &Width, int &Height, double &VideoAspect);
+  virtual void GetOsdSize(int &Width, int &Height, double &PixelAspect);
 
 // Track facilities
 
diff -ruN vdr-1.7.7/dvbplayer.c vdr-1.7.8/dvbplayer.c
--- vdr-1.7.7/dvbplayer.c	2009-04-19 17:19:10.000000000 +0200
+++ vdr-1.7.8/dvbplayer.c	2009-05-31 16:12:42.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: dvbplayer.c 2.15 2009/04/19 15:19:10 kls Exp $
+ * $Id: dvbplayer.c 2.17 2009/05/31 14:12:42 kls Exp $
  */
 
 #include "dvbplayer.h"
@@ -89,7 +89,6 @@
   uchar *buffer;
   int wanted;
   int length;
-  bool hasData;
   cCondWait newSet;
   cCondVar newDataCond;
   cMutex newDataMutex;
@@ -99,7 +98,8 @@
   cNonBlockingFileReader(void);
   ~cNonBlockingFileReader();
   void Clear(void);
-  int Read(cUnbufferedFile *File, uchar *Buffer, int Length);
+  void Request(cUnbufferedFile *File, int Length);
+  int Result(uchar **Buffer);
   bool Reading(void) { return buffer; }
   bool WaitForDataMs(int msToWait);
   };
@@ -110,7 +110,6 @@
   f = NULL;
   buffer = NULL;
   wanted = length = 0;
-  hasData = false;
   Start();
 }
 
@@ -128,29 +127,27 @@
   free(buffer);
   buffer = NULL;
   wanted = length = 0;
-  hasData = false;
+  Unlock();
+}
+
+void cNonBlockingFileReader::Request(cUnbufferedFile *File, int Length)
+{
+  Lock();
+  Clear();
+  wanted = Length;
+  buffer = MALLOC(uchar, wanted);
+  f = File;
   Unlock();
   newSet.Signal();
 }
 
-int cNonBlockingFileReader::Read(cUnbufferedFile *File, uchar *Buffer, int Length)
+int cNonBlockingFileReader::Result(uchar **Buffer)
 {
-  if (hasData && buffer) {
-     if (buffer != Buffer) {
-        esyslog("ERROR: cNonBlockingFileReader::Read() called with different buffer!");
-        errno = EINVAL;
-        return -1;
-        }
+  LOCK_THREAD;
+  if (buffer && length == wanted) {
+     *Buffer = buffer;
      buffer = NULL;
-     return length;
-     }
-  if (!buffer) {
-     f = File;
-     buffer = Buffer;
-     wanted = Length;
-     length = 0;
-     hasData = false;
-     newSet.Signal();
+     return wanted;
      }
   errno = EAGAIN;
   return -1;
@@ -160,20 +157,23 @@
 {
   while (Running()) {
         Lock();
-        if (!hasData && f && buffer) {
+        if (f && buffer && length < wanted) {
            int r = f->Read(buffer + length, wanted - length);
-           if (r >= 0) {
+           if (r > 0)
               length += r;
-              if (!r || length == wanted) { // r == 0 means EOF
-                 cMutexLock NewDataLock(&newDataMutex);
-                 hasData = true;
-                 newDataCond.Broadcast();
-                 }
+           else if (r == 0) { // r == 0 means EOF
+              if (length > 0)
+                 wanted = length; // already read something, so return the rest
+              else
+                 length = wanted = 0; // report EOF
               }
-           else if (r < 0 && FATALERRNO) {
+           else if (FATALERRNO) {
               LOG_ERROR;
-              length = r; // this will forward the error status to the caller
-              hasData = true;
+              length = wanted = r; // this will forward the error status to the caller
+              }
+           if (length == wanted) {
+              cMutexLock NewDataLock(&newDataMutex);
+              newDataCond.Broadcast();
               }
            }
         Unlock();
@@ -184,7 +184,7 @@
 bool cNonBlockingFileReader::WaitForDataMs(int msToWait)
 {
   cMutexLock NewDataLock(&newDataMutex);
-  if (hasData)
+  if (buffer && length == wanted)
      return true;
   return newDataCond.TimedWait(newDataMutex, msToWait);
 }
@@ -381,7 +381,6 @@
 
 void cDvbPlayer::Action(void)
 {
-  uchar *b = NULL;
   uchar *p = NULL;
   int pc = 0;
 
@@ -461,10 +460,12 @@
                       esyslog("ERROR: frame larger than buffer (%d > %d)", Length, MAXFRAMESIZE);
                       Length = MAXFRAMESIZE;
                       }
-                   b = MALLOC(uchar, Length);
+                   if (!eof)
+                      nonBlockingFileReader->Request(replayFile, Length);
                    }
                 if (!eof) {
-                   int r = nonBlockingFileReader->Read(replayFile, b, Length);
+                   uchar *b = NULL;
+                   int r = nonBlockingFileReader->Result(&b);
                    if (r > 0) {
                       WaitingForData = false;
                       uint32_t Pts = 0;
@@ -473,15 +474,16 @@
                          LastReadIFrame = readIndex;
                          }
                       readFrame = new cFrame(b, -r, ftUnknown, readIndex, Pts); // hands over b to the ringBuffer
-                      b = NULL;
                       }
-                   else if (r == 0)
-                      eof = true;
                    else if (r < 0 && errno == EAGAIN)
                       WaitingForData = true;
-                   else if (r < 0 && FATALERRNO) {
-                      LOG_ERROR;
-                      break;
+                   else {
+                      if (r == 0)
+                         eof = true;
+                      else if (r < 0 && FATALERRNO) {
+                         LOG_ERROR;
+                         break;
+                         }
                       }
                    }
                 }
